<?php
namespace Inti\Db;

/**
 * Class ConfigProvider
 *
 * @package Inti\Db
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-db
 */
final class ConfigProvider
{
    /**
     * @return array
     */
    public function __invoke(): array
    {
        return [
            'dependencies' => $this->getDependencies(),

            'db.connections' => [
                'connections' => [
                    'default' => [
                        'driver' => 'pdo_mysql',
                        'charset' => 'utf8mb4',
                        'host' => 'localhost',
                        'user' => '',
                        'password' => '',
                        'dbname' => '',
                    ],
                ],
            ],

            'middleware_pipeline' => [[
                'middleware' => Middleware\DbMiddleware::class,
                'priority' => 75,
            ]],
        ];
    }

    /**
     * @return array
     */
    public function getDependencies(): array
    {
        return [
            'factories' => [
                Connection\ConnectionManager::class => Connection\ConnectionManagerFactory::class,
                Middleware\DbMiddleware::class => Middleware\DbMiddlewareFactory::class,
            ],
        ];
    }
}
