<?php
namespace Inti\Db\Connection;

use Doctrine\DBAL\Driver\Connection;
use Zend\ServiceManager\AbstractPluginManager;
use Zend\ServiceManager\ServiceManager;

/**
 * Class ConnectionPluginManager
 *
 * @package Inti\Db\Connection
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-db
 */
final class ConnectionManager extends AbstractPluginManager
{
    const CONFIG_KEY = 'db.connections';
    /** @var string */
    protected $instanceOf = Connection::class;

    /**
     * ConnectionManager constructor.
     * @param ServiceManager|null $container
     * @param array $config
     */
    public function __construct($container = null, array $config = [])
    {
        if (isset($config['connections']) && is_array($config['connections'])) {
            foreach ($config['connections'] as $name => $options) {
                $config['factories'][$name] = ConnectionFactory::class;
            }

            unset($config['connections']);
        }

        parent::__construct($container, $config);
    }
}
