<?php
namespace Inti\Db\Connection;

use Psr\Container\ContainerInterface;

/**
 * Class ConnectionManagerFactory
 *
 * @package Inti\Db\Connection
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-db
 */
final class ConnectionManagerFactory
{
    /**
     * @param ContainerInterface $container
     * @return ConnectionManager
     */
    public function __invoke(ContainerInterface $container): ConnectionManager
    {
        $config = $container->get('config')[ConnectionManager::CONFIG_KEY] ?? [];
        return new ConnectionManager($container, $config);
    }
}
