<?php
namespace Inti\Db\Middleware;

use Doctrine\DBAL\Connection;
use Doctrine\DBAL\Driver\Connection as DbalConnection;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;

/**
 * Class DbMiddleware
 *
 * @package Inti\Db\Middleware
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-db
 */
final class DbMiddleware implements MiddlewareInterface
{
    /** @var DbalConnection|Connection */
    private DbalConnection $connection;

    /**
     * Konstruktor.
     *
     * @param DbalConnection $connection
     */
    public function __construct(DbalConnection $connection)
    {
        $this->connection = $connection;
    }

    /**
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        $this->connection->connect();

        return $handler->handle(
            $request->withAttribute('db', $this->connection)
        );
    }
}
