<?php
namespace Inti\Db\Middleware;

use Doctrine\DBAL\Driver\Connection as DbalConnection;
use Interop\Container\ContainerInterface;
use Inti\Db\Connection\ConnectionManager;
use Zend\ServiceManager\Factory\FactoryInterface;

/**
 * Class DbMiddlewareFactory
 *
 * @package Inti\Db\Middleware
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-db
 */
final class DbMiddlewareFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @return object|void
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        /** @var ConnectionManager $connectionManager */
        $connectionManager = $container->get(ConnectionManager::class);
        /** @var DbalConnection $connection */
        $connection = $connectionManager->get('default');

        return new DbMiddleware($connection);
    }
}
